package com.tmax.openframe;

import com.tmax.openframe.response.ResponseCode;
import com.tmax.openframe.Handling;
import com.tmax.openframe.option.*;
import com.tmax.openframe.eib.EIB;
import com.tmax.openframe.task.Task;
import com.tmax.openframe.SystemData;
import com.tmax.openframe.support.exception.*;
import com.tmax.openframe.dof.*;
import com.tmax.openframe.dto.*;
import com.tmax.openframe.mapper.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.openframe.tsq.TSQ;
import com.tmax.openframe.file.*;
import com.tmax.openframe.syncpoint.*;
import com.tmax.openframe.intervalcontrol.*;
import com.tmax.openframe.command.*;
import java.util.Objects;
import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.dto.OIVPUPDT_InputDto;
import com.tmax.openframe.dto.OIVPUPDT_OutputDto;
import com.tmax.openframe.variable.OIVPUPDT_VariableContainer;
import com.tmax.openframe.variable.condition.*;
import com.tmax.openframe.variable.group.*;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.model.dataobject.DataObject;
import java.lang.Runnable;
import java.math.*;
import java.util.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPUPDT implements Runnable {
    private @Getter Integer returnValue = 0;
    private @Getter OIVPUPDT_VariableContainer container = new OIVPUPDT_VariableContainer();
    Runnable _0000_MAIN = this::_0000_MAIN;
    Runnable _0100_FIRST_TIME = this::_0100_FIRST_TIME;
    Runnable _0200_UPDATE = this::_0200_UPDATE;
    Runnable _0300_GO_MAIN = this::_0300_GO_MAIN;
    Runnable _5100_ALWAYS_TEST = this::_5100_ALWAYS_TEST;
    Runnable _5200_INFO = this::_5200_INFO;
    Runnable _5300_RETURN_TRANS_ID = this::_5300_RETURN_TRANS_ID;
    Runnable _5400_QUIT = this::_5400_QUIT;
    Runnable _7100_RECEIVEMAP = this::_7100_RECEIVEMAP;
    Runnable _7200_SENDMAP = this::_7200_SENDMAP;
    Runnable _7250_SENDMAP_DATA = this::_7250_SENDMAP_DATA;
    Runnable _9100_INVALID_KEY = this::_9100_INVALID_KEY;
    Runnable _9999_ABORT = this::_9999_ABORT;
    Runnable GoTo;
    boolean Return;
    ArrayList<Runnable> MethodFlow = new ArrayList<>();
    {
        MethodFlow.add(_0000_MAIN);
        MethodFlow.add(_0100_FIRST_TIME);
        MethodFlow.add(_0200_UPDATE);
        MethodFlow.add(_0300_GO_MAIN);
        MethodFlow.add(_5100_ALWAYS_TEST);
        MethodFlow.add(_5200_INFO);
        MethodFlow.add(_5300_RETURN_TRANS_ID);
        MethodFlow.add(_5400_QUIT);
        MethodFlow.add(_7100_RECEIVEMAP);
        MethodFlow.add(_7200_SENDMAP);
        MethodFlow.add(_7250_SENDMAP_DATA);
        MethodFlow.add(_9100_INVALID_KEY);
        MethodFlow.add(_9999_ABORT);
    }
    @Getter
    EIB eib = new Task().getEib();
    @Getter
    boolean Start;
    @Getter
    Handling handling = new Handling();
    @Getter
    SystemData systemData = new SystemData();
    @Getter
    @Setter
    WaitObject waitObject;
    @Getter
    @Setter
    OIVPUPDT_InputDto inputDto;
    @Getter
    @Setter
    OIVPUPDT_OutputDto outputDto;
    @Getter
    @Setter
    DataObject startInputDto;

    public OIVPUPDT() {
        container.setDFHCOMMAREA(StringUtils.repeat(' ', 1));
    }

    public @Override void run() {
        run(_0000_MAIN, _9999_ABORT);
    }

    private void run(Runnable start) throws CicsException {
        run(start, null);
    }

    private void run(Runnable start, Runnable end) throws CicsException {
        List<Runnable> runList;
        if (end == null) {
            runList = Collections.singletonList(start);
        } else {
            runList = MethodFlow.subList(MethodFlow.indexOf(start),
                    MethodFlow.indexOf(end) + 1);
        }
        int i = 0;
        while (i < runList.size()) {
            runList.get(i).run();
            if (GoTo != null) {
                for (Runnable runUnit : runList) {
                    if (GoTo == runUnit) {
                        i = runList.indexOf(runUnit);
                        GoTo = null;
                        break;
                    }
                }
                if (GoTo != null) {
                    return;
                }
            } else {
                i++;
            }
            if (Return) {
                return;
            }
        }
    }

    void _0000_MAIN() throws CicsException {
        run(_5100_ALWAYS_TEST);
        if (GoTo != null || Return) {
            return;
        }
        if (OIVPUPDT_WS_FIRST_TIME_FLAG_CONDITION.FIRST_TIME.test(container
                .getWS_FIRST_TIME_FLAG())) {
            run(_0100_FIRST_TIME);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPUPDT_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.ENTER_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0200_UPDATE);
            if (GoTo != null || Return) {
                return;
            }
        } else if (OIVPUPDT_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.PF1_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_0300_GO_MAIN);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9100_INVALID_KEY);
            if (GoTo != null || Return) {
                return;
            }
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0100_FIRST_TIME() throws CicsException {
        container.setOIVPM05I(OIVPUPDT_OIVPM05I.createDefaultValueInstance());
        container.setMSGO("ENTER APPROPRIATE VALUES");
        run(_5200_INFO);
        if (GoTo != null || Return) {
            return;
        }
        // ("EXEC CICS READQ TS QUEUE(TSQ01) INTO(WSKEY) LENGTH(LEN1) END-EXEC");
        try {
            ReadqTSOption option = ReadqTSOption.builder()
                    .queue(container.getTSQ01())
                    .into(container.getPEOPLE_INFO().getWSKEY())
                    .length((int) container.getLEN1()).build();
            TSQ.read(option);
            container.getPEOPLE_INFO().setWSKEY((int) option.getInto());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS READ FILE(FILE01) RIDFLD(WSKEY) KEYLENGTH(LEN) INTO(PEOPLE-INFO) LENGTH(DATALEN) END-EXEC");
        try {
            ReadOption option = ReadOption
                    .builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getPEOPLE_INFO()
                            .getWSKEY()))
                    .keylength((int) container.getLEN())
                    .into(OIVPUPDT_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO()))
                    .length((int) container.getDATALEN()).build();
            File.read(option, OIVPDS_DOF.class);
            container
                    .setPEOPLE_INFO(OIVPUPDT_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toSource((OIVPDS_DO) option.getInto()));
            container.getPEOPLE_INFO().setWSKEY(
                    Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setIDENO(String
                .valueOf(container.getPEOPLE_INFO().getWSKEY()));
        container.setNAMEO(container.getPEOPLE_INFO().getWS_NAME());
        container.setDEPTO(container.getPEOPLE_INFO().getWS_DEPARTMENT());
        container.setPHONO(container.getPEOPLE_INFO().getWS_PHONE());
        container.setEMALO(container.getPEOPLE_INFO().getWS_EMAIL());
        container.setADDRO(container.getPEOPLE_INFO().getWS_ADDRESS());
        // ("EXEC CICS DELETEQ TS QUEUE(TSQ01) END-EXEC");
        try {
            DeleteqTSOption option = DeleteqTSOption.builder()
                    .queue(container.getTSQ01()).build();
            TSQ.delete(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0200_UPDATE() throws CicsException {
        run(_7100_RECEIVEMAP);
        if (GoTo != null || Return) {
            return;
        }
        container.getPEOPLE_INFO().setWSKEY(
                Integer.parseInt(container.getOIVPM05I().getIDENI()));
        container.getPEOPLE_INFO().setWS_NAME(
                container.getOIVPM05I().getNAMEI());
        container.getPEOPLE_INFO().setWS_DEPARTMENT(
                container.getOIVPM05I().getDEPTI());
        container.getPEOPLE_INFO().setWS_PHONE(
                container.getOIVPM05I().getPHONI());
        container.getPEOPLE_INFO().setWS_EMAIL(
                container.getOIVPM05I().getEMALI());
        container.getPEOPLE_INFO().setWS_ADDRESS(
                container.getOIVPM05I().getADDRI());
        // ("EXEC CICS READ FILE(FILE01) RIDFLD(WSKEY) UPDATE TOKEN(TOK) KEYLENGTH(LEN) INTO(PEOPLE-INFO-TEMP) LENGTH(DATALEN) END-EXEC");
        try {
            ReadOption option = ReadOption
                    .builder()
                    .file(container.getFILE01())
                    .ridfld(String.valueOf(container.getPEOPLE_INFO()
                            .getWSKEY()))
                    .token(container.getTOK())
                    .keylength((int) container.getLEN())
                    .into(OIVPUPDT_PEOPLE_INFO_TEMP_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO_TEMP()))
                    .length((int) container.getDATALEN()).build();
            File.read(option, OIVPDS_DOF.class);
            container
                    .setPEOPLE_INFO_TEMP(OIVPUPDT_PEOPLE_INFO_TEMP_To_OIVPDS_DOMapper.INSTANCE
                            .toSource((OIVPDS_DO) option.getInto()));
            container.setTOK(option.getToken());
            container.getPEOPLE_INFO().setWSKEY(
                    Integer.parseInt(option.getRidfld()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS REWRITE FILE(FILE01) TOKEN(TOK) FROM(PEOPLE-INFO) LENGTH(DATALEN) END-EXEC");
        try {
            RewriteOption option = RewriteOption
                    .builder()
                    .file(container.getFILE01())
                    .token(container.getTOK())
                    .from(OIVPUPDT_PEOPLE_INFO_To_OIVPDS_DOMapper.INSTANCE
                            .toTarget(container.getPEOPLE_INFO()))
                    .length((int) container.getDATALEN()).build();
            File.rewrite(option, OIVPDS_DOF.class);
            container.setTOK(option.getToken());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS SYNCPOINT END-EXEC");
        try {
            Syncpoint.commit();
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setMSGO("DATA UPDATED");
        // ("EXEC CICS DELAY FOR SECONDS(1) END-EXEC");
        try {
            DelayOption option = DelayOption.builder().delayFor(true)
                    .isDuration(true).seconds(1).build();
            IntervalControlService.delay(option);
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        run(_7200_SENDMAP);
        if (GoTo != null || Return) {
            return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _0300_GO_MAIN() throws CicsException {
        // ("EXEC CICS START TRANSID('OIVP') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIVP")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPMAIN_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        run(_5300_RETURN_TRANS_ID);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _5100_ALWAYS_TEST() throws CicsException {
        container.setDEFINITIONS_OF_EIBAID_FIELD(eib.getEibAid());
        if (OIVPUPDT_DEFINITIONS_OF_EIBAID_FIELD_CONDITION.CLEAR_KEY
                .test(container.getDEFINITIONS_OF_EIBAID_FIELD())) {
            run(_5400_QUIT);
            if (GoTo != null || Return) {
                return;
            }
        }
        // ("EXEC CICS ASSIGN STARTCODE(START-CODE) END-EXEC");
        try {
            AssignOption option = AssignOption.builder()
                    .startcode(container.getSTART_CODE()).inputDto(inputDto)
                    .build();
            SystemEnv.assign(option);
            container.setSTART_CODE(option.getStartcode());
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        if (StringUtils.stripEnd(container.getSTART_CODE(), " ")
                .compareTo("TD") == 0 && eib.getEibCalen() != 0) {
            container.setWS_FIRST_TIME_FLAG(1);
        } else {
            container.setWS_FIRST_TIME_FLAG(0);
        }
    }

    void _5200_INFO() throws CicsException {
        // ("EXEC CICS LINK PROGRAM ('OIVPINFO') COMMAREA (WS-DATE-TIME-AREA) END-EXEC");
        try {
            LinkOption option = LinkOption
                    .builder()
                    .program("OIVPINFO")
                    .commarea(
                            OIVPUPDT_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                                    .toOIVPINFO_DFHCOMMAREADto(container
                                            .getWS_DATE_TIME_AREA()))
                    .inputDto(new OIVPINFO_InputDto()).build();
            ProgramInvoke.link(option);
            container
                    .setWS_DATE_TIME_AREA(OIVPUPDT_WS_DATE_TIME_AREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                            .toOIVPUPDT_WS_DATE_TIME_AREA((OIVPINFO_DFHCOMMAREADto) option
                                    .getCommarea()));
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        container.setDATEO(container.getWS_DATE_TIME_AREA().getDCA_DATE());
        container.setTERMO(container.getWS_DATE_TIME_AREA().getDCA_TERM());
        container.setTIMEO(container.getWS_DATE_TIME_AREA().getDCA_TIME()
                .toString());
    }

    void _5300_RETURN_TRANS_ID() throws CicsException {
        // ("EXEC CICS RETURN TRANSID('OIUP') COMMAREA(WS-COMMUNICATION-AREA) END-EXEC");
        try {
            OIVPUPDT_DFHCOMMAREADto dfhcommareaDto = new OIVPUPDT_DFHCOMMAREADto();
            dfhcommareaDto.setDFHCOMMAREA(container.getWS_COMMUNICATION_AREA());
            ReturnOption option = ReturnOption.builder().transid("OIUP")
                    .commarea(dfhcommareaDto).outputDto(outputDto).build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _5400_QUIT() throws CicsException {
        // ("EXEC CICS START TRANSID('OIQU') TERMID(EIBTRMID) RESP(WS-RESPONSE-CODE) END-EXEC");
        try {
            StartOption option = StartOption.builder().transid("OIQU")
                    .termid(eib.getEibTrmid())
                    .inputDto(new OIVPQUIT_InputDto()).build();
            IntervalControlService.start(option);
            WaitObject object = option.getWaitObject();
            setWaitObject(object);
            Start = true;
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPUPDT_DFHCOMMAREADto dfhcommareaDto = new OIVPUPDT_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7100_RECEIVEMAP() throws CicsException {
        // ("EXEC CICS RECEIVE MAP ('OIVPM05') MAPSET ('OIVPM05') INTO (OIVPM05I) RESP (WS-RESPONSE-CODE) END-EXEC");
        try {
            ReceiveMapOption option = ReceiveMapOption.builder().build();
            OIVPM05_OIVPM05_dataToOIVPUPDT_OIVPM05IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM05_OIVPM05_data(),
                            container.getOIVPM05I());
            OIVPM05_OIVPM05_metaToOIVPUPDT_OIVPM05IMapperInterface.INSTANCE
                    .toTarget(
                            inputDto.getScreenDto().getOIVPM05_OIVPM05_meta(),
                            container.getOIVPM05I());
        } catch (CicsConditionException e) {
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            container.setWS_RESPONSE_CODE(eib.getEibResp());
            if (GoTo != null)
                return;
        }
        if (container.getWS_RESPONSE_CODE() == ResponseCode.NORMAL
                .getResponseCode()) {
        } else if (container.getWS_RESPONSE_CODE() == ResponseCode.MAPFAIL
                .getResponseCode()) {
            container.setMSGO("FAIL; ENTER APPROPRIATE VALUES");
            run(_7250_SENDMAP_DATA);
            if (GoTo != null || Return) {
                return;
            }
            run(_5300_RETURN_TRANS_ID);
            if (GoTo != null || Return) {
                return;
            }
        } else {
            run(_9999_ABORT);
            if (GoTo != null || Return) {
                return;
            }
        }
    }

    void _7200_SENDMAP() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM05') MAPSET('OIVPM05') FROM(OIVPM05O) ERASE END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPUPDT_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM05");
            outputDto.getScreenDto().setMapSetName("OIVPM05");
            try {
                OIVPM05_OIVPM05_data oivpm05_oivpm05_data = new OIVPM05_OIVPM05_data();
                OIVPM05_OIVPM05_meta oivpm05_oivpm05_meta = new OIVPM05_OIVPM05_meta();
                OIVPUPDT_OIVPM05OToOIVPM05_OIVPM05_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM05O(), oivpm05_oivpm05_data);
                OIVPUPDT_OIVPM05OToOIVPM05_OIVPM05_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM05O(), oivpm05_oivpm05_meta);
                outputDto.getScreenDto().setOIVPM05_OIVPM05_data(
                        oivpm05_oivpm05_data);
                outputDto.getScreenDto().setOIVPM05_OIVPM05_meta(
                        oivpm05_oivpm05_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _7250_SENDMAP_DATA() throws CicsException {
        // ("EXEC CICS SEND MAP('OIVPM05') MAPSET('OIVPM05') FROM(OIVPM05O) DATAONLY END-EXEC");
        try {
            outputDto.setScreenDto(new OIVPUPDT_ScreenDto());
            outputDto.setId("tranExecute");
            outputDto.getScreenDto().setMapName("OIVPM05");
            outputDto.getScreenDto().setMapSetName("OIVPM05");
            try {
                OIVPM05_OIVPM05_data oivpm05_oivpm05_data = new OIVPM05_OIVPM05_data();
                OIVPM05_OIVPM05_meta oivpm05_oivpm05_meta = new OIVPM05_OIVPM05_meta();
                OIVPUPDT_OIVPM05OToOIVPM05_OIVPM05_dataMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM05O(), oivpm05_oivpm05_data);
                OIVPUPDT_OIVPM05OToOIVPM05_OIVPM05_metaMapperInterface.INSTANCE
                        .toTarget(container.getOIVPM05O(), oivpm05_oivpm05_meta);
                outputDto.getScreenDto().setOIVPM05_OIVPM05_data(
                        oivpm05_oivpm05_data);
                outputDto.getScreenDto().setOIVPM05_OIVPM05_meta(
                        oivpm05_oivpm05_meta);
            } catch (Exception e) {
                throw new CicsConditionException(47);
            }
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }

    void _9100_INVALID_KEY() throws CicsException {
        container.setOIVPM05I(OIVPUPDT_OIVPM05I.createDefaultValueInstance());
        container.setMSGO("INVALID KEY, <ENTER> OR <CLEAR>");
        run(_7250_SENDMAP_DATA);
        if (GoTo != null || Return) {
            return;
        }
    }

    void _9999_ABORT() throws CicsException {
        container.getWS_ERROR_MESSAGE().setWS_EIBTRNID(eib.getEibTranid());
        container.getWS_ERROR_MESSAGE().setWS_EIBRSRCE(eib.getEibRsrce());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP(eib.getEibResp());
        container.getWS_ERROR_MESSAGE().setWS_EIBRESP2(eib.getEibResp2());
        // ("EXEC CICS SEND TEXT FROM ('ERROR') ERASE ALARM FREEKB END-EXEC");
        try {
            outputDto.getScreenDto().setText("ERROR");
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
        // ("EXEC CICS RETURN END-EXEC");
        try {
            if (Objects.equals("DS", inputDto.getSystemDto().getStartCode())
                    || Objects.equals("D", inputDto.getSystemDto()
                            .getStartCode())) {
                OIVPUPDT_DFHCOMMAREADto dfhcommareaDto = new OIVPUPDT_DFHCOMMAREADto();
                dfhcommareaDto.setDFHCOMMAREA(container.getDFHCOMMAREA());
                outputDto.getSystemDto().setCommarea("DFHCOMMAREA",
                        dfhcommareaDto);
            }
            ReturnOption option = ReturnOption.builder().outputDto(outputDto)
                    .build();
            ProgramInvoke.returnProgram(option);
            Return = true;
        } catch (CicsConditionException e) {
            GoTo = systemData.getConditionRunnable(e);
        } catch (RuntimeException e) {
            GoTo = systemData.getErrorRunnable(e);
        } finally {
            if (GoTo != null)
                return;
        }
    }
}
